import { Data, DataUnknown } from '../../app/scripts/middleware/data';
import Bitfields from '../../app/scripts/middleware/bitfields';
import { Calc } from '../../app/scripts/math';


/*eslint-disable no-unused-vars*/

// logger
import log from 'logger-level';

const overrideData = {};

class D1_MODE extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_MODE'/*,'D1_G2_AUTO_MODE', 'D1_G2_MAN_MODE', 'D1_G2_TEST_MODE','D1_G2_ASSISTED_MAN','D1_G2_BITFIELD_3', 'D1_G2_BITFIELD_2'*/]);
	}
	valNum() {
		let btnStateMode = -1;

		let D1_G2_MODE = new Data('D1_G2_MODE').valNum();
		//Mode auto
		if (D1_G2_MODE === 1) {
			btnStateMode = 2;
		//Mode man
		} else if (D1_G2_MODE === 3) {
			btnStateMode = 0;
		//Mode test
		} else if (D1_G2_MODE === 2) {
			btnStateMode = 1;
		} else {
			btnStateMode = -1;
		}
		// let D1_G2_AUTO_MODE = new Bitfields('B1_LED_AUTO').val();
		// let D1_G2_MAN_MODE = new Bitfields('B1_LED_MAN').val();
		// let D1_G2_TEST_MODE = new Bitfields('B1_LED_TEST').val();

		// if (D1_G2_AUTO_MODE) {
		// 	btnStateMode = 2;
		// } else if (D1_G2_MAN_MODE) {
		// 	btnStateMode = 0;
		// } else if (D1_G2_TEST_MODE) {
		// 	btnStateMode = 1;
		// } else {
		// 	btnStateMode = -1;
		// }

		// let D1_G2_AUTO_MODE = new Data('D1_G2_AUTO_MODE').valNum();
		// let D1_G2_MAN_MODE = new Data('D1_G2_MAN_MODE').valNum();
		// let D1_G2_TEST_MODE = new Data('D1_G2_TEST_MODE').valNum();

		// Auto Mode
		// if ((D1_G2_AUTO_MODE === 1)
		// 	&& (D1_G2_MAN_MODE === 0)
		// 		&& (D1_G2_TEST_MODE === 0)) {
		// 	btnStateMode = 2;
		// // Manu Mode
		// } else if ((D1_G2_AUTO_MODE === 0)
		// 			&& (D1_G2_MAN_MODE === 1)
		// 				&& (D1_G2_TEST_MODE === 0)) {
		// 	btnStateMode = 0;
		// // Manu assist Mode
		// } else if ((D1_G2_AUTO_MODE === 1)
		// 			&& (D1_G2_MAN_MODE === 0)
		// 				&& (D1_G2_TEST_MODE === 3)) {
		// 	btnStateMode = 0;
		// // Test Mode
		// } else if ((D1_G2_AUTO_MODE === 1)
		// 			&& (D1_G2_MAN_MODE === 0)
		// 				&& (D1_G2_TEST_MODE === 1)) {
		// 	btnStateMode = 1;
		// }
		return btnStateMode;
	}
}

// class D1_MAINS_BREAK_IN extends Data {
// 	constructor(tag) {
// 		super(tag);
// 		this.setDependencies(['D1_G2_INPUT_MAINS_BREAK_IN']);
// 	}
// 	valNum() {
// 		return new Data('D1_G2_INPUT_MAINS_BREAK_IN').valNum();
// 	}
// }

// class D1_GEN_BREAK_IN extends Data {
// 	constructor(tag) {
// 		super(tag);
// 		this.setDependencies(['D1_G2_INPUT_GEN_BREAK_IN']);
// 	}
// 	valNum() {
// 		return new Data('D1_G2_INPUT_GEN_BREAK_IN').valNum();
// 	}
// }

// ----------------------------------------------------------------------------

class D1_G2_CANOPEN_INPUT_1 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 0) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_2 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 1) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_3 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 2) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_4 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 3) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_5 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 4) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_6 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 5) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_7 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 6) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_8 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 7) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_9 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 8) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_10 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 9) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_11 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 10) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_12 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 11) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_13 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 12) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_14 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 13) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_15 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 14) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_16 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 15) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_17 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 16) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_18 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 17) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_19 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 18) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_20 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 19) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_21 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 20) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_22 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 21) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_23 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 22) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_24 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 23) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_25 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 24) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_26 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 25) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_27 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 26) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_28 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 27) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_29 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 28) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_30 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 29) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_31 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 30) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_32 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 31) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_33 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 32) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_34 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 33) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_35 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 34) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_36 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 35) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_37 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 36) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_38 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 37) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_39 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 38) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_INPUT_40 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDIN() > 39) {
			return true;
		}
		return false;
	}
}

class D1_DO01 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 0) {
			return true;
		}
		return false;
	}
}

class D1_DO02 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 1) {
			return true;
		}
		return false;
	}
}

class D1_DO03 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 2) {
			return true;
		}
		return false;
	}
}

class D1_DO04 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 3) {
			return true;
		}
		return false;
	}
}

class D1_DO05 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 4) {
			return true;
		}
		return false;
	}
}

class D1_DO06 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 5) {
			return true;
		}
		return false;
	}
}

class D1_DO07 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 6) {
			return true;
		}
		return false;
	}
}

class D1_DO08 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 7) {
			return true;
		}
		return false;
	}
}

class D1_DO09 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 8) {
			return true;
		}
		return false;
	}
}

class D1_DO10 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 9) {
			return true;
		}
		return false;
	}
}

class D1_DO11 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 10) {
			return true;
		}
		return false;
	}
}

class D1_DO12 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 11) {
			return true;
		}
		return false;
	}
}

class D1_DO13 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 12) {
			return true;
		}
		return false;
	}
}

class D1_DO14 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 13) {
			return true;
		}
		return false;
	}
}

class D1_DO15 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 14) {
			return true;
		}
		return false;
	}
}

class D1_DO16 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 15) {
			return true;
		}
		return false;
	}
}

class D1_DO17 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 16) {
			return true;
		}
		return false;
	}
}

class D1_DO18 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 17) {
			return true;
		}
		return false;
	}
}

class D1_DO19 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 18) {
			return true;
		}
		return false;
	}
}

class D1_DO20 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 19) {
			return true;
		}
		return false;
	}
}

class D1_DO21 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 20) {
			return true;
		}
		return false;
	}
}

class D1_DO22 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 21) {
			return true;
		}
		return false;
	}
}

class D1_DO23 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 22) {
			return true;
		}
		return false;
	}
}

class D1_DO24 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 23) {
			return true;
		}
		return false;
	}
}

class D1_DO25 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 24) {
			return true;
		}
		return false;
	}
}

class D1_DO26 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 25) {
			return true;
		}
		return false;
	}
}

class D1_DO27 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 26) {
			return true;
		}
		return false;
	}
}

class D1_DO28 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 27) {
			return true;
		}
		return false;
	}
}

class D1_DO29 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 28) {
			return true;
		}
		return false;
	}
}

class D1_DO30 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 29) {
			return true;
		}
		return false;
	}
}

class D1_DO31 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 30) {
			return true;
		}
		return false;
	}
}

class D1_DO32 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 31) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_33 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 32) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_34 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 33) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_35 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 34) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_36 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 35) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_37 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 36) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_38 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 37) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_39 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 38) {
			return true;
		}
		return false;
	}
}

class D1_G2_CANOPEN_DO_40 extends Data {
	constructor(tag) {
		super(tag);
	}
	isVisible() {
		let D1_CANOPEN_CONFIG_TYPE = new overrideData.D1_CANOPEN_CONFIG_TYPE('D1_CANOPEN_CONFIG_TYPE');
		if (D1_CANOPEN_CONFIG_TYPE.valNumDOUT() > 39) {
			return true;
		}
		return false;
	}
}

class D1_CANOPEN_CONFIG_TYPE extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies([
			'D1_MOD01_NB_DIGITAL_INPUT', 'D1_MOD02_NB_DIGITAL_INPUT', 'D1_MOD03_NB_DIGITAL_INPUT',
			'D1_MOD04_NB_DIGITAL_INPUT', 'D1_G2_MOD05_NB_DIGITAL_INPUT',
			'D1_MOD01_NB_DIGITAL_OUTPUT', 'D1_MOD02_NB_DIGITAL_OUTPUT', 'D1_MOD03_NB_DIGITAL_OUTPUT',
			'D1_MOD04_NB_DIGITAL_OUTPUT', 'D1_G2_MOD05_NB_DIGITAL_OUTPUT']);
	}
	valNum() {
		if (this.valNumDIN() > this.valNumDOUT()) {
			return this.valNumDIN();
		}
		return this.valNumDOUT();
	}
	valNumDIN() {
		let D1_G2_CANOPEN_DIN_1 = new Data('D1_MOD01_NB_DIGITAL_INPUT').valNum();
		let D1_G2_CANOPEN_DIN_2 = new Data('D1_MOD02_NB_DIGITAL_INPUT').valNum();
		let D1_G2_CANOPEN_DIN_3 = new Data('D1_MOD03_NB_DIGITAL_INPUT').valNum();
		let D1_G2_CANOPEN_DIN_4 = new Data('D1_MOD04_NB_DIGITAL_INPUT').valNum();
		let D1_G2_CANOPEN_DIN_5 = new Data('D1_G2_MOD05_NB_DIGITAL_INPUT').valNum();
		return D1_G2_CANOPEN_DIN_1 + D1_G2_CANOPEN_DIN_2 + D1_G2_CANOPEN_DIN_3 +
			D1_G2_CANOPEN_DIN_4 + D1_G2_CANOPEN_DIN_5;
	}
	valNumDOUT() {
		let D1_G2_CANOPEN_DOUT_1 = new Data('D1_MOD01_NB_DIGITAL_OUTPUT').valNum();
		let D1_G2_CANOPEN_DOUT_2 = new Data('D1_MOD02_NB_DIGITAL_OUTPUT').valNum();
		let D1_G2_CANOPEN_DOUT_3 = new Data('D1_MOD03_NB_DIGITAL_OUTPUT').valNum();
		let D1_G2_CANOPEN_DOUT_4 = new Data('D1_MOD04_NB_DIGITAL_OUTPUT').valNum();
		let D1_G2_CANOPEN_DOUT_5 = new Data('D1_G2_MOD05_NB_DIGITAL_OUTPUT').valNum();
		return D1_G2_CANOPEN_DOUT_1 + D1_G2_CANOPEN_DOUT_2 + D1_G2_CANOPEN_DOUT_3 +
			D1_G2_CANOPEN_DOUT_4 + D1_G2_CANOPEN_DOUT_5;
	}
}

class D1_G2_INFO_1 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_1']);
	}
}

class D1_G2_INFO_2 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_2']);
	}
}

class D1_G2_INFO_3 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_3']);
	}
}

class D1_G2_INFO_4 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_4']);
	}
}

class D1_G2_INFO_5 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_5']);
	}
}

class D1_G2_INFO_6 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_6']);
	}
}

class D1_G2_INFO_7 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_7']);
	}
}

class D1_G2_INFO_8 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_8']);
	}
}

class D1_G2_INFO_9 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_9']);
	}
}

class D1_G2_INFO_10 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_10']);
	}
}

class D1_G2_INFO_11 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_11']);
	}
}

class D1_G2_INFO_12 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_12']);
	}
}

class D1_G2_INFO_13 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_13']);
	}
}

class D1_G2_INFO_14 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_14']);
	}
}

class D1_G2_INFO_15 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_15']);
	}
}

class D1_G2_INFO_16 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_16']);
	}
}

class D1_G2_INFO_17 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_17']);
	}
}

class D1_G2_INFO_18 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_18']);
	}
}

class D1_G2_INFO_19 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_19']);
	}
}

class D1_G2_INFO_20 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_20']);
	}
}

class D1_G2_INFO_21 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_21']);
	}
}

class D1_G2_INFO_22 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_22']);
	}
}

class D1_G2_INFO_23 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_23']);
	}
}

class D1_G2_INFO_24 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_24']);
	}
}

class D1_G2_INFO_25 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_25']);
	}
}

class D1_G2_INFO_26 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_26']);
	}
}

class D1_G2_INFO_27 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_27']);
	}
}

class D1_G2_INFO_28 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_28']);
	}
}

class D1_G2_INFO_29 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_29']);
	}
}

class D1_G2_INFO_30 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_30']);
	}
}

class D1_G2_INFO_31 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_31']);
	}
}

class D1_G2_INFO_32 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_32']);
	}
}

class D1_G2_INFO_33 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_33']);
	}
}

class D1_G2_INFO_34 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_34']);
	}
}

class D1_G2_INFO_35 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_35']);
	}
}

class D1_G2_INFO_36 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_36']);
	}
}

class D1_G2_INFO_37 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_37']);
	}
}

class D1_G2_INFO_38 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_38']);
	}
}

class D1_G2_INFO_39 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_39']);
	}
}

class D1_G2_INFO_40 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_40']);
	}
}

class D1_G2_INFO_41 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_41']);
	}
}

class D1_G2_INFO_42 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_42']);
	}
}

class D1_G2_INFO_43 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_43']);
	}
}

class D1_G2_INFO_44 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_44']);
	}
}

class D1_G2_INFO_45 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_45']);
	}
}

class D1_G2_INFO_46 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_46']);
	}
}

class D1_G2_INFO_47 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_47']);
	}
}

class D1_G2_INFO_48 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_48']);
	}
}

class D1_G2_INFO_49 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_49']);
	}
}

class D1_G2_INFO_50 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_INFO_VALUE_50']);
	}
}

// ----------------------------------------------------------------------------

class D1_LED_STATUS extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_BITFIELD_2', 'D1_G2_BITFIELD_3']);
	}
}

class D1_BITFIELD1 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_BITFIELD_1', 'D1_G2_BITFIELD_2']);
	}
}

class D1_BITFIELD2 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_BITFIELD_3', 'D1_G2_BITFIELD_4']);
	}
}

class D1_BITFIELD3 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_BITFIELD_4']);
	}
}

class D1_BITFIELD4 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_BITFIELD_2']);
	}
}

class D1_BITFIELD7 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_CT_BITFIELD_1', 'D1_G2_AL_CT_BITFIELD_2']);
	}
}

class D1_BITFIELD8 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_2', 'D1_G2_FA_CT_BITFIELD_1', 'D1_G2_FA_CT_BITFIELD_2']);
	}
}

class D1_BITFIELD9 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_AL_CT_BITFIELD_1']);
	}
}

class D1_BITFIELD10 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_FA_CT_BITFIELD_1']);
	}
}

class D1_BITFIELD11 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_4', 'D1_G2_AL_FA_BITFIELD_5', 'D1_G2_AL_FA_BITFIELD_8',
			'D1_G2_AL_CT_BITFIELD_1', 'D1_G2_AL_CT_BITFIELD_2', 'D1_G2_AL_CT_BITFIELD_4']);
	}
}

class D1_BITFIELD12 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_4', 'D1_G2_AL_FA_BITFIELD_5', 'D1_G2_AL_FA_BITFIELD_8',
			'D1_G2_FA_CT_BITFIELD_1', 'D1_G2_FA_CT_BITFIELD_2', 'D1_G2_FA_CT_BITFIELD_4']);
	}
}

class D1_BITFIELD13 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_3', 'D1_G2_AL_CT_BITFIELD_2', 'D1_G2_AL_CT_BITFIELD_3']);
	}
}

class D1_BITFIELD14 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_3', 'D1_G2_FA_CT_BITFIELD_2', 'D1_G2_FA_CT_BITFIELD_3']);
	}
}

class D1_BITFIELD15 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_3', 'D1_G2_AL_FA_BITFIELD_4', 'D1_G2_AL_CT_BITFIELD_2', 'D1_G2_AL_CT_BITFIELD_3']);
	}
}

class D1_BITFIELD16 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_3', 'D1_G2_AL_FA_BITFIELD_4', 'D1_G2_FA_CT_BITFIELD_2', 'D1_G2_FA_CT_BITFIELD_3']);
	}
}

class D1_BITFIELD17 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_AL_FA_BITFIELD_3', 'D1_G2_AL_FA_BITFIELD_5',
			'D1_G2_AL_CT_BITFIELD_1', 'D1_G2_AL_CT_BITFIELD_2', 'D1_G2_AL_CT_BITFIELD_3']);
	}
}

class D1_BITFIELD18 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_AL_FA_BITFIELD_3', 'D1_G2_AL_FA_BITFIELD_5',
			'D1_G2_FA_CT_BITFIELD_1', 'D1_G2_FA_CT_BITFIELD_2', 'D1_G2_FA_CT_BITFIELD_3']);
	}
}

class D1_BITFIELD19 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_3', 'D1_G2_AL_FA_BITFIELD_4', 'D1_G2_AL_CT_BITFIELD_4']);
	}
}

class D1_BITFIELD20 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AL_FA_BITFIELD_1', 'D1_G2_AL_FA_BITFIELD_2', 'D1_G2_AL_FA_BITFIELD_3',
			'D1_G2_FA_CT_BITFIELD_4']);
	}
}


//Generator

class D1_GEN_V1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM']);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_V_NOM').valNum() / Math.sqrt(3)) * 1.5
		);
	}
}

class D1_GEN_V2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_V_NOM').valNum() / Math.sqrt(3)) * 1.5
		);
	}
}

class D1_GEN_V3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_V_NOM').valNum() / Math.sqrt(3)) * 1.5
		);
	}
}

class D1_GEN_U31 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM']);
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_GEN_V_NOM').valNum() * 1.5
		);
	}
}

class D1_GEN_U23 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_GEN_V_NOM').valNum() * 1.5
		);
	}
}

class D1_GEN_U12 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_GEN_V_NOM').valNum() * 1.5
		);
	}
}

class D1_GEN_I1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM', 'D1_GEN_KW_NOM']);
	}

	maxNum() {
		return this.calc.ceilHundred(
		//Pnom * 10^3 (conversion en watt) * 150%
		(new Data('D1_GEN_KW_NOM').valNum() * Math.pow(10, 3) * 1.5) /
		//Vnom * sqrt(3) * 0.8 (dans le pire cas : cosphi (faible) = 0.8)
		(new Data('D1_GEN_V_NOM').valNum() * Math.sqrt(3) * 0.8)
		);
	}
}

class D1_GEN_I2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM', 'D1_GEN_KW_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		//Pnom * 10^3 (conversion en watt) * 150%
		(new Data('D1_GEN_KW_NOM').valNum() * Math.pow(10, 3) * 1.5) /
		//Vnom * sqrt(3) * 0.8 (dans le pire cas : cosphi (faible) = 0.8)
		(new Data('D1_GEN_V_NOM').valNum() * Math.sqrt(3) * 0.8)
		);
	}
}

class D1_GEN_I3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_V_NOM', 'D1_GEN_KW_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		//Pnom * 10^3 (conversion en watt) * 150%
		(new Data('D1_GEN_KW_NOM').valNum() * Math.pow(10, 3) * 1.5) /
		//Vnom * sqrt(3) * 0.8 (dans le pire cas : cosphi (faible) = 0.8)
		(new Data('D1_GEN_V_NOM').valNum() * Math.sqrt(3) * 0.8)
		);
	}
}

class D1_GEN_P1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KW_NOM').valNum() / 3) * -0.2
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KW_NOM').valNum() / 3) * 1.5
		);
	}
}

class D1_GEN_P2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KW_NOM').valNum() / 3) * -0.2
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KW_NOM').valNum() / 3) * 1.5
		);
	}
}

class D1_GEN_P3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KW_NOM').valNum() / 3) * -0.2
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KW_NOM').valNum() / 3) * 1.5
		);
	}
}

class D1_GEN_Q1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() / 3) * -1.5
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() / 3) * 1.5
		);
	}
}

class D1_GEN_Q2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() / 3) * -1.5
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() / 3) * 1.5
		);
	}
}

class D1_GEN_Q3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() / 3) * -1.5
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() / 3) * 1.5
		);
	}
}

class D1_GEN_COSPHI1 extends Data {
	constructor(tag) {
		super(tag);
	}
}

class D1_GEN_COSPHI2 extends Data {
	constructor(tag) {
		super(tag);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}
}

class D1_GEN_COSPHI3 extends Data {
	constructor(tag) {
		super(tag);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}
}

class D1_GEN_KW extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		new Data('D1_GEN_KW_NOM').valNum() * -0.2
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_GEN_KW_NOM').valNum() * 1.5
		);
	}
}

class D1_GEN_KVAR extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		new Data('D1_GEN_KVAR_NOM').valNum() * -1.5
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_GEN_KVAR_NOM').valNum() * 1.5
		);
	}
}

class D1_BUS_V1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_BUS_V_NOM').valNum() / Math.sqrt(3)) * 1.5
		);
	}
}

class D1_BUS_V2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_BUS_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_BUS_V_NOM').valNum() / Math.sqrt(3)) * 1.5
		);
	}
}

class D1_BUS_V3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_BUS_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_BUS_V_NOM').valNum() / Math.sqrt(3)) * 1.5
		);
	}
}

class D1_BUS_U31 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_BUS_V_NOM']);
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_BUS_V_NOM').valNum() * 1.5
		);
	}
}

class D1_BUS_U23 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_BUS_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_BUS_V_NOM').valNum() * 1.5
		);
	}
}

class D1_BUS_U12 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_BUS_V_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_BUS_V_NOM').valNum() * 1.5
		);
	}
}

class D1_BUS_I1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_BUS_CT_RATIO'/*'D1_GEN_KW_NOM'*/]);
	}

	maxNum() {
		return this.calc.ceilHundred(
			//Max I mains = 5 * Mains CT ratio
			new Data('D1_BUS_CT_RATIO').valNum() * 5
		//(PnomGE * 5) * 10^3 (conversion en watt) * 150%
		//(new Data('D1_GEN_KW_NOM').valNum() * 5 * Math.pow(10, 3) * 1.5) /
		//Vnom * sqrt(3) * 0.8 (dans le pire cas : cosphi (faible) = 0.8)
		//(new Data('D1_GEN_V_NOM').valNum() * Math.sqrt(3) * 0.8)
		);
	}
}

class D1_BUS_I2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_G2_BUS_CT_RATIO_2'/*'D1_GEN_KW_NOM'*/]);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
			//Max I mains = 5 * Mains CT ratio
			new Data('D1_G2_BUS_CT_RATIO_2').valNum() * 5
		//(PnomGE * 5) * 10^3 (conversion en watt) * 150%
		//(new Data('D1_GEN_KW_NOM').valNum() * 5 * Math.pow(10, 3) * 1.5) /
		//Vnom * sqrt(3) * 0.8 (dans le pire cas : cosphi (faible) = 0.8)
		//(new Data('D1_GEN_V_NOM').valNum() * Math.sqrt(3) * 0.8)
		);
	}
}

class D1_BUS_I3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_G2_BUS_CT_RATIO_3'/*'D1_GEN_KW_NOM'*/]);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	maxNum() {
		return this.calc.ceilHundred(
			//Max I mains = 5 * Mains CT ratio
			new Data('D1_G2_BUS_CT_RATIO_3').valNum() * 5
		//(PnomGE * 5) * 10^3 (conversion en watt) * 150%
		//(new Data('D1_GEN_KW_NOM').valNum() * 5 * Math.pow(10, 3) * 1.5) /
		//Vnom * sqrt(3) * 0.8 (dans le pire cas : cosphi (faible) = 0.8)
		//(new Data('D1_GEN_V_NOM').valNum() * Math.sqrt(3) * 0.8)
		);
	}
}

class D1_BUS_P extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM', 'D1_MAINS_KW_MEAS', 'D1_G2_4_20_MA_CALIB']);
	}

	minNum() {
		let kWMeasure = new Data('D1_MAINS_KW_MEAS').valNum();
		if (!kWMeasure) {
			return 0;
		}
		return this.calc.floorHundred(
		new Data('D1_GEN_KW_NOM').valNum() * 5 * -0.2
		);
	}

	maxNum() {
		let kWMeasure = new Data('D1_MAINS_KW_MEAS').valNum();
		if (!kWMeasure) {
			return new Data('D1_G2_4_20_MA_CALIB').valNum();
		}
		return this.calc.ceilHundred(
		new Data('D1_GEN_KW_NOM').valNum() * 5 * 1.5
		);
	}
}

class D1_BUS_P1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KW_NOM').valNum() * 5 * -0.2) / 3
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KW_NOM').valNum() * 5 * 1.5) / 3
		);
	}
}

class D1_BUS_P2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KW_NOM').valNum() * 5 * -0.2) / 3
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KW_NOM').valNum() * 5 * 1.5) / 3
		);
	}
}

class D1_BUS_P3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KW_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KW_NOM').valNum() * 5 * -0.2) / 3
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KW_NOM').valNum() * 5 * 1.5) / 3
		);
	}
}

class D1_BUS_Q extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		new Data('D1_GEN_KVAR_NOM').valNum() * 5 * -1.5
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		new Data('D1_GEN_KVAR_NOM').valNum() * 5 * 1.5
		);
	}
}

class D1_BUS_Q1 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() * 5 * -1.5) / 3
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() * 5 * 1.5) / 3
		);
	}
}

class D1_BUS_Q2 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() * 5 * -1.5) / 3
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() * 5 * 1.5) / 3
		);
	}
}

class D1_BUS_Q3 extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_GEN_KVAR_NOM']);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}

	minNum() {
		return this.calc.floorHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() * 5 * -1.5) / 3
		);
	}

	maxNum() {
		return this.calc.ceilHundred(
		(new Data('D1_GEN_KVAR_NOM').valNum() * 5 * 1.5) / 3
		);
	}
}

class D1_BUS_COSPHI1 extends Data {
	constructor(tag) {
		super(tag);
	}
}

class D1_BUS_COSPHI2 extends Data {
	constructor(tag) {
		super(tag);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 2) {
			return true;
		}
		return false;
	}
}

class D1_BUS_COSPHI3 extends Data {
	constructor(tag) {
		super(tag);
	}

	isVisible() {
		let voltageSchema = new Data('D1_VOLTAGE_SCHEMA').valNum();
		if (voltageSchema < 1) {
			return true;
		}
		return false;
	}
}

//Engine

class D1_ENGINE_RPM extends Data {
	constructor(tag) {
		super(tag);
		this.calc = new Calc();
		this.setDependencies(['D1_ACTIVE_SPEED_SETPOINT']);
	}
	maxNum() {
		return this.calc.ceilHundred(
			new Data('D1_ACTIVE_SPEED_SETPOINT').valNum() * 1.5
		);
	}
}

class D1_OIL_PRESS extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_AN1_CALIB01', 'D1_AN1_CALIB02', 'D1_AN1_CALIB03', 'D1_AN1_CALIB04',
			'D1_AN1_CALIB05', 'D1_AN1_CALIB06', 'D1_AN1_CALIB07', 'D1_AN1_CALIB08', 'D1_AN1_CALIB09',
			'D1_AN1_CALIB10', 'D1_AN1_CALIB11']);
		this.tagsArray = ['D1_AN1_CALIB01', 'D1_AN1_CALIB02', 'D1_AN1_CALIB03', 'D1_AN1_CALIB04',
			'D1_AN1_CALIB05', 'D1_AN1_CALIB06', 'D1_AN1_CALIB07', 'D1_AN1_CALIB08', 'D1_AN1_CALIB09',
			'D1_AN1_CALIB10', 'D1_AN1_CALIB11'];
	}
	minNum() {
		let j1939 = new Data('D1_J1939_ENGINE_MODEL').valNum();
		if (!j1939) {
			let calibValArray = [];
			this.tagsArray.forEach((item) => {
				calibValArray.push(new Data(item).valNum());
			});
			//console.log("OIL_PRESS min", Math.min(...calibValArray));
			return Math.min(...calibValArray);
		}
		return new Data('D1_OIL_PRESS').minNum();
	}
	maxNum() {
		const MAX_BAR = 10;
		let unit = new Data('D1_OIL_PRESS').unit();
		let j1939 = new Data('D1_J1939_ENGINE_MODEL').valNum();
		if (!j1939) {
			let calibValArray = [];
			this.tagsArray.forEach((item) => {
				calibValArray.push(new Data(item).valNum());
			});
			//console.log("OIL_PRESS max", Math.max(...calibValArray));
			return Math.max(...calibValArray);
		} else if (unit === 'R2_KILOPASCAL') {
			return MAX_BAR * 100;
		} else if (unit === 'R2_PSI') {
			return MAX_BAR * 14.5038;
		} else if (unit === 'R2_MBAR') {
			return MAX_BAR * 1000;
		}
		return MAX_BAR;
	}
}

class D1_WATER_TEMP extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_AN2_CALIB01', 'D1_AN2_CALIB02', 'D1_AN2_CALIB03', 'D1_AN2_CALIB04',
			'D1_AN2_CALIB05', 'D1_AN2_CALIB06', 'D1_AN2_CALIB07', 'D1_AN2_CALIB08', 'D1_AN2_CALIB09',
			'D1_AN2_CALIB10', 'D1_AN2_CALIB11']);
		this.tagsArray = ['D1_AN2_CALIB01', 'D1_AN2_CALIB02', 'D1_AN2_CALIB03', 'D1_AN2_CALIB04',
			'D1_AN2_CALIB05', 'D1_AN2_CALIB06', 'D1_AN2_CALIB07', 'D1_AN2_CALIB08', 'D1_AN2_CALIB09',
			'D1_AN2_CALIB10', 'D1_AN2_CALIB11'];
	}
	minNum() {
		let j1939 = new Data('D1_J1939_ENGINE_MODEL').valNum();
		if (!j1939) {
			let calibValArray = [];
			this.tagsArray.forEach((item) => {
				calibValArray.push(new Data(item).valNum());
			});
			//console.log("WATER_TEMP min", Math.min(...calibValArray));
			return Math.min(...calibValArray);
		}
		return 0;
	}
	maxNum() {
		const MAX_CELCIUS = 150;
		let unit = new Data('D1_WATER_TEMP').unit();
		let j1939 = new Data('D1_J1939_ENGINE_MODEL').valNum();
		if (!j1939) {
			let calibValArray = [];
			this.tagsArray.forEach((item) => {
				calibValArray.push(new Data(item).valNum());
			});
			//console.log("WATER_TEMP max", Math.max(...calibValArray));
			return Math.max(...calibValArray);
		} else if (unit === 'R2_FARENHEIT') {
			return (MAX_CELCIUS * 1.8) + 32;
		}
		return MAX_CELCIUS;
	}
}

class D1_VOLT_BATT extends Data {
	constructor(tag) {
		super(tag);
	}

	maxNum() {
		return 36;
	}
}

class D1_AN_MEASURE1 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_AN3_CALIB01', 'D1_AN3_CALIB02', 'D1_AN3_CALIB03', 'D1_AN3_CALIB04',
			'D1_AN3_CALIB05', 'D1_AN3_CALIB06', 'D1_AN3_CALIB07', 'D1_AN3_CALIB08', 'D1_AN3_CALIB09',
			'D1_AN3_CALIB10', 'D1_AN3_CALIB11']);
		this.tagsArray = ['D1_AN3_CALIB01', 'D1_AN3_CALIB02', 'D1_AN3_CALIB03', 'D1_AN3_CALIB04',
			'D1_AN3_CALIB05', 'D1_AN3_CALIB06', 'D1_AN3_CALIB07', 'D1_AN3_CALIB08', 'D1_AN3_CALIB09',
			'D1_AN3_CALIB10', 'D1_AN3_CALIB11'];
	}

	minNum() {
		let calibValArray = [];
		this.tagsArray.forEach((item) => {
			calibValArray.push(new Data(item).valNum());
		});
		//console.log("AN1 min", Math.min(...calibValArray));
		return Math.min(...calibValArray);
	}

	maxNum() {
		let calibValArray = [];
		this.tagsArray.forEach((item) => {
			calibValArray.push(new Data(item).valNum());
		});
		//console.log("AN1 max", Math.max(...calibValArray));
		return Math.max(...calibValArray);
	}
}

class D1_AN_MEASURE2 extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_G2_AN4_CALIB01', 'D1_G2_AN4_CALIB02', 'D1_G2_AN4_CALIB03', 'D1_G2_AN4_CALIB04',
			'D1_G2_AN4_CALIB05', 'D1_G2_AN4_CALIB06', 'D1_G2_AN4_CALIB07', 'D1_G2_AN4_CALIB08', 'D1_G2_AN4_CALIB09',
			'D1_G2_AN4_CALIB10', 'D1_G2_AN4_CALIB11']);
		this.tagsArray = ['D1_G2_AN4_CALIB01', 'D1_G2_AN4_CALIB02', 'D1_G2_AN4_CALIB03', 'D1_G2_AN4_CALIB04',
			'D1_G2_AN4_CALIB05', 'D1_G2_AN4_CALIB06', 'D1_G2_AN4_CALIB07', 'D1_G2_AN4_CALIB08', 'D1_G2_AN4_CALIB09',
			'D1_G2_AN4_CALIB10', 'D1_G2_AN4_CALIB11'];
	}
	minNum() {
		let calibValArray = [];
		this.tagsArray.forEach((item) => {
			calibValArray.push(new Data(item).valNum());
		});
		return Math.min(...calibValArray);
	}

	maxNum() {
		let calibValArray = [];
		this.tagsArray.forEach((item) => {
			calibValArray.push(new Data(item).valNum());
		});
		return Math.max(...calibValArray);
	}
}

class D1_J1939_MTU_ERROR_CODE extends Data {
	constructor(tag) {
		super(tag);
	}

	isVisible() {
		return false;
	}
}

//Maintenance meter

class D1_METER_1_HOUR extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_HOUR_CYCLE1']);
	}
}

class D1_METER_2_HOUR extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_HOUR_CYCLE2']);
	}
}

class D1_METER_3_HOUR extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_HOUR_CYCLE3']);
	}
}

class D1_METER_4_HOUR extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_HOUR_CYCLE4']);
	}
}

class D1_METER_5_HOUR extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_HOUR_CYCLE5']);
	}
}

class D1_METER_1_DAY extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_DAY_CYCLE1']);
	}
}

class D1_METER_2_DAY extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_DAY_CYCLE2']);
	}
}

class D1_METER_3_DAY extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_DAY_CYCLE3']);
	}
}

class D1_METER_4_DAY extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_DAY_CYCLE4']);
	}
}

class D1_METER_5_DAY extends Data {
	constructor(tag) {
		super(tag);
		this.setDependencies(['D1_DAY_CYCLE5']);
	}
}

//Synchro

class D1_VOLT_BUS_GEN extends Data {
	constructor(tag) {
		super(tag);
	}
	minNum() {
		return -20;
	}
	maxNum() {
		return 20;
	}
}

class D1_FREQ_BUS_GEN extends Data {
	constructor(tag) {
		super(tag);
	}
	minNum() {
		return -3;
	}
	maxNum() {
		return 3;
	}
}

// ----------------------------------------------------------------------------

overrideData.D1_MODE = D1_MODE;
// overrideData.D1_MAINS_BREAK_IN = D1_MAINS_BREAK_IN;
// overrideData.D1_GEN_BREAK_IN = D1_GEN_BREAK_IN;

overrideData.D1_CANOPEN_CONFIG_TYPE = D1_CANOPEN_CONFIG_TYPE;
overrideData.D1_G2_CANOPEN_INPUT_1 = D1_G2_CANOPEN_INPUT_1;
overrideData.D1_G2_CANOPEN_INPUT_2 = D1_G2_CANOPEN_INPUT_2;
overrideData.D1_G2_CANOPEN_INPUT_3 = D1_G2_CANOPEN_INPUT_3;
overrideData.D1_G2_CANOPEN_INPUT_4 = D1_G2_CANOPEN_INPUT_4;
overrideData.D1_G2_CANOPEN_INPUT_5 = D1_G2_CANOPEN_INPUT_5;
overrideData.D1_G2_CANOPEN_INPUT_6 = D1_G2_CANOPEN_INPUT_6;
overrideData.D1_G2_CANOPEN_INPUT_7 = D1_G2_CANOPEN_INPUT_7;
overrideData.D1_G2_CANOPEN_INPUT_8 = D1_G2_CANOPEN_INPUT_8;
overrideData.D1_G2_CANOPEN_INPUT_9 = D1_G2_CANOPEN_INPUT_9;
overrideData.D1_G2_CANOPEN_INPUT_10 = D1_G2_CANOPEN_INPUT_10;
overrideData.D1_G2_CANOPEN_INPUT_11 = D1_G2_CANOPEN_INPUT_11;
overrideData.D1_G2_CANOPEN_INPUT_12 = D1_G2_CANOPEN_INPUT_12;
overrideData.D1_G2_CANOPEN_INPUT_13 = D1_G2_CANOPEN_INPUT_13;
overrideData.D1_G2_CANOPEN_INPUT_14 = D1_G2_CANOPEN_INPUT_14;
overrideData.D1_G2_CANOPEN_INPUT_15 = D1_G2_CANOPEN_INPUT_15;
overrideData.D1_G2_CANOPEN_INPUT_16 = D1_G2_CANOPEN_INPUT_16;
overrideData.D1_G2_CANOPEN_INPUT_17 = D1_G2_CANOPEN_INPUT_17;
overrideData.D1_G2_CANOPEN_INPUT_18 = D1_G2_CANOPEN_INPUT_18;
overrideData.D1_G2_CANOPEN_INPUT_19 = D1_G2_CANOPEN_INPUT_19;
overrideData.D1_G2_CANOPEN_INPUT_20 = D1_G2_CANOPEN_INPUT_20;
overrideData.D1_G2_CANOPEN_INPUT_21 = D1_G2_CANOPEN_INPUT_21;
overrideData.D1_G2_CANOPEN_INPUT_22 = D1_G2_CANOPEN_INPUT_22;
overrideData.D1_G2_CANOPEN_INPUT_23 = D1_G2_CANOPEN_INPUT_23;
overrideData.D1_G2_CANOPEN_INPUT_24 = D1_G2_CANOPEN_INPUT_24;
overrideData.D1_G2_CANOPEN_INPUT_25 = D1_G2_CANOPEN_INPUT_25;
overrideData.D1_G2_CANOPEN_INPUT_26 = D1_G2_CANOPEN_INPUT_26;
overrideData.D1_G2_CANOPEN_INPUT_27 = D1_G2_CANOPEN_INPUT_27;
overrideData.D1_G2_CANOPEN_INPUT_28 = D1_G2_CANOPEN_INPUT_28;
overrideData.D1_G2_CANOPEN_INPUT_29 = D1_G2_CANOPEN_INPUT_29;
overrideData.D1_G2_CANOPEN_INPUT_30 = D1_G2_CANOPEN_INPUT_30;
overrideData.D1_G2_CANOPEN_INPUT_31 = D1_G2_CANOPEN_INPUT_31;
overrideData.D1_G2_CANOPEN_INPUT_32 = D1_G2_CANOPEN_INPUT_32;
overrideData.D1_G2_CANOPEN_INPUT_33 = D1_G2_CANOPEN_INPUT_33;
overrideData.D1_G2_CANOPEN_INPUT_34 = D1_G2_CANOPEN_INPUT_34;
overrideData.D1_G2_CANOPEN_INPUT_35 = D1_G2_CANOPEN_INPUT_35;
overrideData.D1_G2_CANOPEN_INPUT_36 = D1_G2_CANOPEN_INPUT_36;
overrideData.D1_G2_CANOPEN_INPUT_37 = D1_G2_CANOPEN_INPUT_37;
overrideData.D1_G2_CANOPEN_INPUT_38 = D1_G2_CANOPEN_INPUT_38;
overrideData.D1_G2_CANOPEN_INPUT_39 = D1_G2_CANOPEN_INPUT_39;
overrideData.D1_G2_CANOPEN_INPUT_40 = D1_G2_CANOPEN_INPUT_40;

overrideData.D1_DO01 = D1_DO01;
overrideData.D1_DO02 = D1_DO02;
overrideData.D1_DO03 = D1_DO03;
overrideData.D1_DO04 = D1_DO04;
overrideData.D1_DO05 = D1_DO05;
overrideData.D1_DO06 = D1_DO06;
overrideData.D1_DO07 = D1_DO07;
overrideData.D1_DO08 = D1_DO08;
overrideData.D1_DO09 = D1_DO09;
overrideData.D1_DO10 = D1_DO10;
overrideData.D1_DO11 = D1_DO11;
overrideData.D1_DO12 = D1_DO12;
overrideData.D1_DO13 = D1_DO13;
overrideData.D1_DO14 = D1_DO14;
overrideData.D1_DO15 = D1_DO15;
overrideData.D1_DO16 = D1_DO16;
overrideData.D1_DO17 = D1_DO17;
overrideData.D1_DO18 = D1_DO18;
overrideData.D1_DO19 = D1_DO19;
overrideData.D1_DO20 = D1_DO20;
overrideData.D1_DO21 = D1_DO21;
overrideData.D1_DO22 = D1_DO22;
overrideData.D1_DO23 = D1_DO23;
overrideData.D1_DO24 = D1_DO24;
overrideData.D1_DO25 = D1_DO25;
overrideData.D1_DO26 = D1_DO26;
overrideData.D1_DO27 = D1_DO27;
overrideData.D1_DO28 = D1_DO28;
overrideData.D1_DO29 = D1_DO29;
overrideData.D1_DO30 = D1_DO30;
overrideData.D1_DO31 = D1_DO31;
overrideData.D1_DO32 = D1_DO32;
overrideData.D1_G2_CANOPEN_DO_33 = D1_G2_CANOPEN_DO_33;
overrideData.D1_G2_CANOPEN_DO_34 = D1_G2_CANOPEN_DO_34;
overrideData.D1_G2_CANOPEN_DO_35 = D1_G2_CANOPEN_DO_35;
overrideData.D1_G2_CANOPEN_DO_36 = D1_G2_CANOPEN_DO_36;
overrideData.D1_G2_CANOPEN_DO_37 = D1_G2_CANOPEN_DO_37;
overrideData.D1_G2_CANOPEN_DO_38 = D1_G2_CANOPEN_DO_38;
overrideData.D1_G2_CANOPEN_DO_39 = D1_G2_CANOPEN_DO_39;
overrideData.D1_G2_CANOPEN_DO_40 = D1_G2_CANOPEN_DO_40;

overrideData.D1_G2_INFO_1 = D1_G2_INFO_1;
overrideData.D1_G2_INFO_2 = D1_G2_INFO_2;
overrideData.D1_G2_INFO_3 = D1_G2_INFO_3;
overrideData.D1_G2_INFO_4 = D1_G2_INFO_4;
overrideData.D1_G2_INFO_5 = D1_G2_INFO_5;
overrideData.D1_G2_INFO_6 = D1_G2_INFO_6;
overrideData.D1_G2_INFO_7 = D1_G2_INFO_7;
overrideData.D1_G2_INFO_8 = D1_G2_INFO_8;
overrideData.D1_G2_INFO_9 = D1_G2_INFO_9;
overrideData.D1_G2_INFO_10 = D1_G2_INFO_10;
overrideData.D1_G2_INFO_11 = D1_G2_INFO_11;
overrideData.D1_G2_INFO_12 = D1_G2_INFO_12;
overrideData.D1_G2_INFO_13 = D1_G2_INFO_13;
overrideData.D1_G2_INFO_14 = D1_G2_INFO_14;
overrideData.D1_G2_INFO_15 = D1_G2_INFO_15;
overrideData.D1_G2_INFO_16 = D1_G2_INFO_16;
overrideData.D1_G2_INFO_17 = D1_G2_INFO_17;
overrideData.D1_G2_INFO_18 = D1_G2_INFO_18;
overrideData.D1_G2_INFO_19 = D1_G2_INFO_19;
overrideData.D1_G2_INFO_20 = D1_G2_INFO_20;
overrideData.D1_G2_INFO_21 = D1_G2_INFO_21;
overrideData.D1_G2_INFO_22 = D1_G2_INFO_22;
overrideData.D1_G2_INFO_23 = D1_G2_INFO_23;
overrideData.D1_G2_INFO_24 = D1_G2_INFO_24;
overrideData.D1_G2_INFO_25 = D1_G2_INFO_25;
overrideData.D1_G2_INFO_26 = D1_G2_INFO_26;
overrideData.D1_G2_INFO_27 = D1_G2_INFO_27;
overrideData.D1_G2_INFO_28 = D1_G2_INFO_28;
overrideData.D1_G2_INFO_29 = D1_G2_INFO_29;
overrideData.D1_G2_INFO_30 = D1_G2_INFO_30;
overrideData.D1_G2_INFO_31 = D1_G2_INFO_31;
overrideData.D1_G2_INFO_32 = D1_G2_INFO_32;
overrideData.D1_G2_INFO_33 = D1_G2_INFO_33;
overrideData.D1_G2_INFO_34 = D1_G2_INFO_34;
overrideData.D1_G2_INFO_35 = D1_G2_INFO_35;
overrideData.D1_G2_INFO_36 = D1_G2_INFO_36;
overrideData.D1_G2_INFO_37 = D1_G2_INFO_37;
overrideData.D1_G2_INFO_38 = D1_G2_INFO_38;
overrideData.D1_G2_INFO_39 = D1_G2_INFO_39;
overrideData.D1_G2_INFO_40 = D1_G2_INFO_40;
overrideData.D1_G2_INFO_41 = D1_G2_INFO_41;
overrideData.D1_G2_INFO_42 = D1_G2_INFO_42;
overrideData.D1_G2_INFO_43 = D1_G2_INFO_43;
overrideData.D1_G2_INFO_44 = D1_G2_INFO_44;
overrideData.D1_G2_INFO_45 = D1_G2_INFO_45;
overrideData.D1_G2_INFO_46 = D1_G2_INFO_46;
overrideData.D1_G2_INFO_47 = D1_G2_INFO_47;
overrideData.D1_G2_INFO_48 = D1_G2_INFO_48;
overrideData.D1_G2_INFO_49 = D1_G2_INFO_49;
overrideData.D1_G2_INFO_50 = D1_G2_INFO_50;

//generator
overrideData.D1_GEN_V1 = D1_GEN_V1;
overrideData.D1_GEN_V2 = D1_GEN_V2;
overrideData.D1_GEN_V3 = D1_GEN_V3;
overrideData.D1_GEN_U31 = D1_GEN_U31;
overrideData.D1_GEN_U23 = D1_GEN_U23;
overrideData.D1_GEN_U12 = D1_GEN_U12;
overrideData.D1_GEN_I1 = D1_GEN_I1;
overrideData.D1_GEN_I2 = D1_GEN_I2;
overrideData.D1_GEN_I3 = D1_GEN_I3;
overrideData.D1_GEN_P1 = D1_GEN_P1;
overrideData.D1_GEN_P2 = D1_GEN_P2;
overrideData.D1_GEN_P3 = D1_GEN_P3;
overrideData.D1_GEN_Q1 = D1_GEN_Q1;
overrideData.D1_GEN_Q2 = D1_GEN_Q2;
overrideData.D1_GEN_Q3 = D1_GEN_Q3;
overrideData.D1_GEN_COSPHI1 = D1_GEN_COSPHI1;
overrideData.D1_GEN_COSPHI2 = D1_GEN_COSPHI2;
overrideData.D1_GEN_COSPHI3 = D1_GEN_COSPHI3;
overrideData.D1_GEN_KW = D1_GEN_KW;
overrideData.D1_GEN_KVAR = D1_GEN_KVAR;

//bus
overrideData.D1_BUS_V1 = D1_BUS_V1;
overrideData.D1_BUS_V2 = D1_BUS_V2;
overrideData.D1_BUS_V3 = D1_BUS_V3;
overrideData.D1_BUS_U31 = D1_BUS_U31;
overrideData.D1_BUS_U23 = D1_BUS_U23;
overrideData.D1_BUS_U12 = D1_BUS_U12;
overrideData.D1_BUS_I1 = D1_BUS_I1;
overrideData.D1_BUS_I2 = D1_BUS_I2;
overrideData.D1_BUS_I3 = D1_BUS_I3;
overrideData.D1_BUS_KW = D1_BUS_P;
overrideData.D1_BUS_KVAR = D1_BUS_Q;
overrideData.D1_BUS_P1 = D1_BUS_P1;
overrideData.D1_BUS_P2 = D1_BUS_P2;
overrideData.D1_BUS_P3 = D1_BUS_P3;
overrideData.D1_BUS_Q1 = D1_BUS_Q1;
overrideData.D1_BUS_Q2 = D1_BUS_Q2;
overrideData.D1_BUS_Q3 = D1_BUS_Q3;
overrideData.D1_BUS_COSPHI1 = D1_BUS_COSPHI1;
overrideData.D1_BUS_COSPHI2 = D1_BUS_COSPHI2;
overrideData.D1_BUS_COSPHI3 = D1_BUS_COSPHI3;

//engine
overrideData.D1_ENGINE_RPM = D1_ENGINE_RPM;
overrideData.D1_OIL_PRESS = D1_OIL_PRESS;
overrideData.D1_WATER_TEMP = D1_WATER_TEMP;
overrideData.D1_VOLT_BATT = D1_VOLT_BATT;
overrideData.D1_AN_MEASURE1 = D1_AN_MEASURE1;
overrideData.D1_AN_MEASURE2 = D1_AN_MEASURE2;
overrideData.D1_J1939_MTU_ERROR_CODE = D1_J1939_MTU_ERROR_CODE;
//maintenance
overrideData.D1_METER_1_HOUR = D1_METER_1_HOUR;
overrideData.D1_METER_2_HOUR = D1_METER_2_HOUR;
overrideData.D1_METER_3_HOUR = D1_METER_3_HOUR;
overrideData.D1_METER_4_HOUR = D1_METER_4_HOUR;
overrideData.D1_METER_5_HOUR = D1_METER_5_HOUR;
overrideData.D1_METER_1_DAY = D1_METER_1_DAY;
overrideData.D1_METER_2_DAY = D1_METER_2_DAY;
overrideData.D1_METER_3_DAY = D1_METER_3_DAY;
overrideData.D1_METER_4_DAY = D1_METER_4_DAY;
overrideData.D1_METER_5_DAY = D1_METER_5_DAY;

//Synchro
overrideData.D1_VOLT_BUS_GEN = D1_VOLT_BUS_GEN;
overrideData.D1_FREQ_BUS_GEN = D1_FREQ_BUS_GEN;

export default overrideData;

/*/////////////////////////////////////////
// overrideData
///////////////////////////////////////////*/

/*/////////////////////////////////////////
// overrideData
///////////////////////////////////////////*/

// class D1_SYSTEM_INFO_BITFIELD extends Data {
// 	constructor(tag) {
// 		super(tag);
// 	}
// 	val() {
// 		return super.val();
// 	}
// }
// overrideData.D1_SYSTEM_INFO_BITFIELD = D1_SYSTEM_INFO_BITFIELD;

// /*eslint-disable no-unused-vars*/
// class D1_AN_MEASURE1 extends Data {
// 	constructor(tag) {
// 		super(tag);
// 	}
// 	val() {
// 		//console.log('D1_AN_MEASURE1: ' + super.val());
// 		return super.val();
// 	}
// }
// overrideData.D1_AN_MEASURE1 = D1_AN_MEASURE1;
//
// class D1_AN_MEASURE2 extends Data {
// 	constructor(tag) {
// 		super(tag);
// 	}
// 	val() {
// 		// console.log('D1_AN_MEASURE2(val): ' + super.val());
// 		// console.log('D1_AN_MEASURE2(min): ' + super.min());
// 		// console.log('D1_AN_MEASURE2(max): ' + super.max());
// 		return super.val();
// 	}
// }
// overrideData.D1_AN_MEASURE2 = D1_AN_MEASURE2;
//
// class D1_AN_MEASURE3 extends Data {
// 	constructor(tag) {
// 		super(tag);
// 	}
// 	val() {
// 		//console.log('D1_AN_MEASURE3: ' + super.val());
// 		return super.val();
// 	}
// }
// overrideData.D1_AN_MEASURE3 = D1_AN_MEASURE3;
//
// class D1_RTC_MINUTE extends Data {
// 	constructor(tag) {
// 		super(tag);
// 		this.setDependencies(['D1_RTC_SECOND']);
// 	}
// 	val() {
// 		return super.val() + ' : ' + instance.getData('D1_RTC_SECOND').val();
// 	}
// }
// overrideData.D1_RTC_MINUTE = D1_RTC_MINUTE;
//
// class D1_NB_GROUP extends Data {
// 	constructor(tag) {
// 		super(tag);
// 	}
// 	isVisible() {
// 	if ((instance.getData('D1_RTC_SECOND').val() > 10)
// 	|| (instance.getData('D1_RTC_SECOND').val() < 30)) {
// 			return false;
// 		}
// 		return true;
// 	}
// }
// overrideData.D1_NB_GROUP = D1_NB_GROUP;
